'=============================================================================
' Fraktal DUST
' DUST.BAS
' Erstellt Maerz 2006
' Letzte Ueberarbeitung 18.12.13
'=============================================================================


#Include "Inc\Common.bi"
#Include "Inc\TUI.bas"


Dim Shared As Single x0, y0, alpha1, alpha2, r1, r2, xmax, Farbe
Dim As Single x, y, x_alt, y_alt
Dim As Integer i
Dim As String*1 jn


Sub Info
  Zentriert(1, "Programm DUST")
  Print
  Print "vgl. H. Lauwerier: Fraktale, 1989, Kapitel 8"
  Print
  Print "Vom Anfangspunkt (x0, y0) ausgehend wird eine Punktfolge nach"
  Print "folgendem Verfahren generiert:"
  Print
  Print "FOR i = 1 TO 1E6"
  Print "  IF RND(1) < 0.5 THEN L1(r1, alpha1) ELSE L2(r2, alpha2)"
  Print "  PSET (x, y)"
  Print "NEXT i"
  Print
  Print "d.h. es wird zufaellig zwischen zwei verschiedenen Transformationen"
  Print "gewaehlt. L1 ist eine Drehmultiplikation um den Koordinatenursprung"
  Print "mit dem Winkel alpha1 und dem Reduktionsfaktor r1. L2 ist eine"
  Print "Drehmultiplikation um den Punkt (1, 0) mit dem Winkel alpha2 und dem"
  Print "Reduktionsfaktor r2."
End Sub


Sub Dateneingabe
  
  Dim As String Maske(7), s(7)
    
  Maske(0) = "Anfangswert x0 ..........: ": s(0) = Str(x0)
  Maske(1) = "Anfangswert y0 ..........: ": s(1) = Str(y0)
  Maske(2) = "Drehwinkel alpha1 in Grad: ": s(2) = Str(alpha1)
  Maske(3) = "Reduktionsfaktor r1 (< 1): ": s(3) = Str(r1)
  Maske(4) = "Drehwinkel alpha2 in Grad: ": s(4) = Str(alpha2)
  Maske(5) = "Reduktionsfaktor r2 (< 1): ": s(5) = Str(r2)
  Maske(6) = "Fensterbreite          +/- ": s(6) = Str(xmax)
  Maske(7) = "Farbe (1 bis 15) ........: ": s(7) = Str(Farbe)
  
  Rahmen("Dateneingabe", "Beenden mit ESC", 20, 15, 31, 65)
  Locate 22, 17
  Eingabe(Maske(), s(), 15)
    
  x0      = Val(s(0))
  y0      = Val(s(1))
  alpha1  = Val(s(2))
  r1      = Val(s(3))
  alpha2  = Val(s(4))
  r2      = Val(s(5))
  xmax    = Val(s(6))
  Farbe   = Val(s(7))
  
  Locate 50, 1
  
End Sub  


Sub L1(r As Single, Alpha As Single, x_alt As Single, y_alt As Single, _
       Byref x As Single, Byref y As Single)
  'Drehmultiplikation um den Koordinatenursprung mit dem Reduktionsfaktor r
  
  Dim As Single a, b
  
  a = r * Cos(pi*Alpha/180)
  b = r * Sin(pi*Alpha/180)
  x = a*x_alt - b*y_alt
  y = b*x_alt + a*y_alt
  
End Sub


Sub L2(r As Single, Alpha As Single, x_alt As Single, y_alt As Single, _
       Byref x As Single, Byref y As Single)
  'Drehmultiplikation um den Punkt (1, 0) mit dem Reduktionsfaktor r
  
  Dim As Single c, d
  
  c = r * Cos(pi*Alpha/180)
  d = r * Sin(pi*Alpha/180)
  x = c*(x_alt - 1) - d*y_alt + 1
  y = d*(x_alt - 1) + c*y_alt
  
End Sub


'----------------------------- Hauptprogramm: ----------------------------------  


alpha1 = 30
alpha2 = 30
r1 = 0.9
r2 = 0.33
x0 = 1
y0 = -1
xmax = 1
Farbe = 3

Do

	Screen 0
	Width 80, 50
	Color 7, 1
	Cls
	
	Info
	Dateneingabe
	
	x = x0
	y = y0
	Screenres 640, 480
	Windowtitle "Dust"
	Width 80, 30
	Cls
	Window(-1.3*xmax, -xmax) - (1.3*xmax, xmax)
	For i = 1 To 1E6
	  x_alt = x
	  y_alt = y
	  If Rnd(1) < 0.5 Then
	    L1(r1, alpha1, x_alt, y_alt, x, y)
	  Else
	    L2(r2, alpha2, x_alt, y_alt, x, y)
	  End If
	  Pset (x, y), Farbe
	Next i
	
	Locate 29, 30
	Input "Noch einmal j/n: ", jn
	
Loop Until Ucase(jn) = "N"

End



