'==========================================================================
' Iteratives Gleichungsloesen
' Iteration.bas                         
' Erstellt 04.12.07
' Letzte Ueberarbeitung am 18.12.13
'==========================================================================

#include "Inc\Komplex.bas"

Dim As Single x_Start, y_Start, dt
Dim As COMPLEX z0, z1, a, b 
Dim As Integer n, k
Dim As String*1 jn

Screen 0
Color 7, 1
Cls

Print "     Programm ITERATION - Iteratives Gleichungsloesen fuer z^n = 1"
Print
Print "Siehe Gerthsen Physik, 23. Auflage, Kapitel 20.4.3"
Print
Print "Fuer die Gleichung z^n = 1, also die n-te Einheitswurzel, lautet das"
Print "Newton-Verfahren zur iterativen Loesung:"
Print
Print "  z -> z - (z^n - 1)/(n * z^(n-1)) = (1 - 1/n)*z + 1/(n*z^(n-1))"
Print "  mit z = x + i*y."
Print
Print "Die resultierenden Punktfolgen werden in der komplexen x-y-Ebene als"
Print "Animationsfilm dargestellt, wobei nach je vierhundert Startpunkten der"
Print "Bildschirm geloescht und neu beschrieben wird. Gut zu erkennen sind die"
Print "n Loesungen (Konvergenzpunkte) fuer z."
Print
Print "<Weiter: Beliebige Taste>"
Locate 25, 1
Getkey

Screenres 640, 480
Windowtitle "Iteration"
Width 80, 30
Window(-7, -5) - (7, 5)

Do

	Cls
	Locate 28, 10: Input "Exponent n (>= 2): ", n
	Locate 29, 10: Input "Bild-Verzoegerungszeit in ms (Richtwert 30): ", dt
	a.Re = 1 - 1/n
	a. Im = 0
	b. Re = 1/n
	b.Im = 0
	For x_Start = -2 To 2 Step 0.01
	  Sleep dt
	  Cls
	  For y_Start = -2 To 2 Step 0.01
	    z0.Re = x_Start
	    z0.Im = y_Start
	    For k = 0 To 100
	      z1 = CAdd(CMult(a, z0), CDiv(b, CPotenz(z0, n-1)))
	      Pset (z1.Re, z1.Im), 13
	      z0 = z1
	    Next k
	  Next y_Start
	Next x_Start
	
	Locate 29, 10
	Input "Noch einmal jn: ", jn
	
Loop Until Ucase(jn) = "N"

End
