'==============================================================================
' Julia. bas
' Julia-Fraktal mit Zoom-Funktion
' Erstellt am 09.05.10
' Letzte Bearbeitung am 18.12.13
'==============================================================================

#INCLUDE "Inc\KOMPLEX.bas"
#INCLUDE "Inc\GRAPHIK.bas"
#INCLUDE "Inc\TUI.bas"

Dim Shared As Single xmin, xmax, ymin, ymax, a, b
Dim As Integer key


Sub Info

  Screen 0
  Color 0, 7
  Width 80, 40
  Cls
  
  Zentriert(1, "Julia-Fraktal")
  Print
  Print "Das Julia-Fraktal wird durch die Iteration z -> z^2 + c erzeugt. z und"
  Print "c sind komplexe Zahlen, mit z = x + i * y, c = a + i * b. Fuer einen"
  Print "vorgegebenen Wert c wird fuer jedes Wertepaar x und y innerhalb der"
  Print "x-y-Ebene untersucht, ob die aus der Iteration erzeugte Folge der"
  Print "z-Werte konvergiert oder nicht. Im Programm wird geprueft, nach wie"
  Print "vielen Iterationen der Betrag von z einen Mindestwert ueberschreitet"
  Print "(hier 100), wobei nach maximal 50 Iterationen abgebrochen wird. Die"
  Print "Zahl der Iterationen wird in der x-y-Ebene fuer jeden Wert von (x, y)"
  Print "als Farbwert eingetragen. In der berechneten Grafik kann mit Hilfe der"
  Print "Maus ein Ausschnitt zum Vergroessern ausgewaehlt werden (Zoom-Funktion)."
  Print
  Print "Siehe Hans Lauwerier, Fraktale, sowie JuliaFrac.bas in der QBMonFaq."
  Print
  Print "Interessante Werte fuer a, b:"
  Print "(0, 1), (-0.9, 0), (0.1, -0.8)"

    
End Sub


Sub Dateneingabe
  
  Dim As String Maske(1), s(1)
  
  Color 7, 1
  Rahmen("Dateneingabe", "Beenden mit ESC", 20, 25, 25, 55)
  Maske(0) = "a = ": s(0) = Str(a)
  Maske(1) = "b = ": s(1) = Str(b)
  Locate 22, 27
  Eingabe(Maske(), s(), 15)
  a = Val(s(0))
  b = Val(s(1))
  Locate 40, 1

End Sub


Sub Julia
  
  Dim As Single x, y, dx, dy
  Dim As COMPLEX z, c, z1, z2
  Dim As Integer i, j, count, clr
  
  Screenres 640, 480
  Windowtitle "Julia-Fraktal"
  Width 80, 30
  View Print 29 To 30
  View (0, 0) - (640, 440)
  Window (xmin, ymin)-(xmax, ymax)
  dx = (xmax - xmin) / 640
  dy = (ymax - ymin) / 480
  c.Re = a
  c.Im = b
  For i = 1 To 640
    x = xmin + i * dx
    For j = 1 To 480
      y = ymin + j * dy
      z.Re = x
      z.Im = y
      count = 0
      Do
        z = CAdd(CPotenz(z, 2), c)
        count = count + 1
      Loop Until CAbs(z) > 50 Or count > 50
      If count > 50 Then Pset(x, y), 0 Else Pset (x, y), 32 + count
    Next j
  Next i
  
End Sub
        
        
Sub Zoom
  
  Dim As Integer xp, yp, Taste
  
  Print "Linke obere Ecke des gewuenschten Ausschnittes anklicken!"
  Do
    Sleep 1
    Getmouse xp, yp,,Taste
  Loop Until Bit(Taste, 0) And xp > 0 And yp > 0
  Sleep 300 'Entprellzeit fuer die Maus  
  xmin = Pmap(xp + 1, 2)
  ymax = Pmap(yp + 1, 3)
  Draw String (xmin - 0.5 * TextWidth("+"), ymax + 0.5 * TextHeight("+")), "+" 
  
  Print "Rechte untere Ecke des gewuenschten Ausschnittes anklicken!"
  Do
    Sleep 1
    Getmouse xp, yp,,Taste
  Loop Until Bit(Taste, 0) And xp > 0 And yp > 0
  Sleep 300
  xmax = Pmap(xp + 1, 2)
  ymin = Pmap(yp + 1, 3)
  Draw String (xmax - 0.5 * TextWidth("+"), ymin + 0.5 * TextHeight("+")), "+"
    
  Line (xmax, ymin) - (xmin, ymax),,B
  Sleep 1000   
  
End Sub
    
    
'------------------------------------ Hauptprogramm: ---------------------------

a = -0.9
b = 0

Do
  xmin = -2
  xmax = 2
  ymin = -1.4
  ymax = 1.4
  Info
  Dateneingabe
  Do
    Julia
    Print "F1: Zoom   F2: Dateneingabe    ESC: Ende"
    Do
      key = Getkey
    Loop Until key = SC_F1 Or key = SC_F2 Or key = SC_ESC
    If key = SC_F1 Then Zoom
  Loop Until key = SC_F2 Or key = SC_ESC
Loop Until key = SC_ESC

End


