'===========================================================================
' Verkrumpelungslinien
' KRUMPEL.BAS
' Erstellt im Maerz 2006
' Letzte Ueberarbeitung 18.12.13
'===========================================================================


#Include "Inc\TUI.bas"


Dim Shared As Single Alpha, r, xmin, ymin, xmax, ymax
Dim Shared As Integer v, m, p, Farbe
Dim As Single x0, y0, x, y
Dim As Integer n, k
Dim As String*1 jn


Sub Info
  Zentriert(1, "PROGRAMM KRUMPEL - Verkrumpelungslinien")
  Print
  Print "Siehe H. Lauwerier: Fraktale, 1989, Kapitel 4 und 8"
  Print
  Print "Die Konstruktion der Verkrumpelungslinien beruht auf einem passend"
  Print "gewaehlten Zahlensystem mit der Basis v. Die Rangordnung der"
  Print "beabsichtigten Annaeherung ist p (begrenzt durch die graphische"
  Print "Aufloesung). Die Verkrumpelungslinien bestehen aus Liniensegmenten,"
  Print "die mit n = 0 bis (v + 1)*v^(p-1) durchnumeriert werden. Jedes"
  Print "Liniensegment wird um einen konstanten Drehwinkel alpha gedreht und"
  Print "hat eine Laenge r^k. r ist ein Reduktionsfaktor, k errechnet sich"
  Print "ueber die Anzahl Faktoren von v in n."
  Print
  Print "Um geschlossene Linien zu erhalten, muss (v+1)*alpha ein Vielfaches"
  Print "von 360 Grad sein, d.h. alpha = m * 360/(v+1)."
End Sub


Sub Dateneingabe
  
  Dim As String Maske(8), s(8)
    
  Maske(0) = "v ...................: ": s(0) = Str(v)
  Maske(1) = "Faktor m fuer alpha  : ": s(1) = Str(m)
  Maske(2) = "r ...................: ": s(2) = Str(r)
  Maske(3) = "p ...................: ": s(3) = Str(p)
  Maske(4) = "Fenstergrenze xmin   : ": s(4) = Str(xmin)
  Maske(5) = "Fenstergrenze ymin   : ": s(5) = Str(ymin)
  Maske(6) = "Fenstergrenze xmax   : ": s(6) = Str(xmax)
  Maske(7) = "Fenstergrenze ymax   : ": s(7) = Str(ymax)
  Maske(8) = "Farbe (1 bis 15) ....: ": s(8) = Str(Farbe)  
  
  Rahmen("Dateneingabe", "Beenden mit ESC", 20, 20, 32, 60)
  Locate 22, 22
  Eingabe(Maske(), s(), 15)
  Locate 50, 1
    
  v     = Val(s(0))
  m     = Val(s(1))
  r     = Val(s(2))
  p     = Val(s(3))
  xmin  = Val(s(4))
  ymin  = Val(s(5))
  xmax  = Val(s(6))
  ymax  = Val(s(7))
  Farbe = Val(s(8))
    
End Sub
   
   
Function AnzFak(v As Integer, n As Integer) As Integer
'  Berechnung der Anzahl Faktoren von v in n

  Dim As Integer F
  Dim As Single a, b 
  
  If n = 0 Then
    AnzFak = 0
  Else
    F = 0
    a = n
    Do
      F = F + 1
      b = a/v
      a = b
    Loop Until b - Int(b) <> 0
    AnzFak = F - 1
  End If
  
End Function
     
  
Sub L(r As Single, x0 As Single, y0 As Single, n As Integer, _
      Byref x As Single, Byref y As Single)
'  Berechnet vom Punkt (x0, y0) ausgehend ein Liniensegment
'  nach (x0 + r, y0), und dreht dieses um n*alpha, wodurch sich der neue
'  Punkt (x, y) ergibt.

  Dim As Single x1, y1, a, b
  
  x1 = x0 + r
  y1 = y0
  a = Cos(pi*n*Alpha/180)
  b = Sin(pi*n*Alpha/180)
  x = a*(x1 - x0) - b*(y1 - y0) + x0
  y = b*(x1 - x0) + a*(y1 - y0) + y0
  
End Sub
  
  
'------------------------------ Hauptprogramm: ---------------------------------


x0 = 0
y0 = 0
v = 3
m = 1
r = 0.47
p = 7
xmin = -1.3
ymin = -0.5
xmax = 0.5
ymax = 0.9
Farbe = 3

Do

	Screen 0
	Width 80, 50
	Color 7, 1
	Cls
	
	Info
	Dateneingabe
	Alpha = m*360/(v+1)
	
	Screenres 640, 480
	Windowtitle "Verkrumpelungslinien"
	Width 80, 30
	Window (xmin, ymin) - (xmax, ymax)
	For n = 0 To (v + 1)*v^(p-1)
	  If AnzFak(v, n) > p - 1 Then k = 0 Else k = p - 1 - AnzFak(v, n)
	  L(r^k, x0, y0, n, x, y)
	  Line (x0, y0) - (x, y), Farbe
	  x0 = x
	  y0 = y
	Next n
	
	Locate 29, 30
	Input "Noch einmal j/n: ", jn
	
Loop Until Ucase(jn) = "N"

End


