'==============================================================================
' Modifizierte Fraktale nach MIRA
' MIRA-mod.bas
' Erstellt Maerz 2006
' Letzte Uberarbeitung 20.12.13 
'==============================================================================
  
  
#include "Inc\TUI.bas"


Dim Shared As Single a, b, c, Alpha, x0, y0, x, y, xmax
Dim Shared As Integer Farbe
Dim As Single x_alt
Dim As Integer n
Dim As String*1 jn


' ---------------------------------- Prozeduren ----------------------------

Sub Info
  Zentriert(1, "Modifiziertes Fraktal nach MIRA")
  Print
  Print "vgl. H. Lauwerier: Fraktale, 1989, Kapitel 8"
  Print
  Print "Bildung der Punktreihe"
  Print "  x(n) = b * y(n-1) + F(x(n-1))"
  Print "  y(n) = -x(n-1) + F(x(n))"
  Print "mit"
  Print "  F(x) = a*x             fuer ABS(x) <= 1"
  Print "  F(x) = a*x + c*(x-1)   fuer x > 1"
  Print "  F(x) = a*x + c*(x+1)   fuer x < -1"
  Print
  Print "Spezielle Parameterwahlen in diesem Programm: b = 1, ABS(a+c) < 1."
  Print "Fuer ABS(a+c) < 1 verhaelt sich die iterative Abbildung  global wie"
  Print "eine wiederholte Drehung um den Winkel alpha, wobei"
  Print "COS(alpha) = a + c ist."
  Print "Eingabeparameter sind also a und alpha (b = 1)."
End Sub


Sub Dateneingabe
  
  Dim As String Maske(5), s(5)
    
  Maske(0) = "a ...................: ": s(0) = Str(a)
  Maske(1) = "alpha ...............: ": s(1) = Str(Alpha)
  Maske(2) = "Startwert x0 ........: ": s(2) = Str(x0)
  Maske(3) = "Startwert y0 ........: ": s(3) = Str(y0)
  Maske(4) = "Fensterbreite      +/- ": s(4) = Str(xmax)
  Maske(5) = "Farbe (1 bis 15).....: ": s(5) = Str(Farbe)  
   
  Rahmen("Dateneingabe", "Beenden mit ESC", 20, 20, 29, 60)  
  Locate 22, 22
  Eingabe(Maske(), s(), 15, 5)
  Locate 50, 1
    
  a     = Val(s(0))
  Alpha = Val(s(1))
  x0    = Val(s(2))
  y0    = Val(s(3))
  xmax  = Val(s(4))
  Farbe = Val(s(5))  
  
End Sub
  

Function F(x As Single) As Single
  If Abs(x) <= 1 Then
    F = a*x
  Elseif x > 1 Then 
    F = a*x + c*(x-1)
  Elseif x < 1 Then  
    F = a*x + c*(x+1)
  End If 
End Function


'-------------------------------- Hauptprogramm: ------------------------------

'Vorbelegte Werte:
a = 3.5
Alpha = 60
b = 1
x0 = 0.1
y0 = 0
xmax = 300
Farbe = 9

Do
  
  Screen 0
  Width 80, 50
  Color 7, 1
  Cls
  
  Info
  Dateneingabe
  
  Screenres 640, 480
  Windowtitle "Modifiziertes Mira-Fraktal"
  Width 80, 30
  Window (-xmax, -0.7*xmax) - (xmax, 0.7*xmax)
  x = x0
  y = y0
  c = Cos(pi*Alpha/180) - a
  For n = 1 To 1E5
    x_alt = x
    x = b*y + F(x_alt)
    y = -x_alt + F(x)
    Pset (x, y), Farbe
  Next n
  
  Locate 29, 30
  Input "Noch einmal j/n: ", jn
  
Loop Until Ucase(jn) = "N"

End



