'==============================================================================
' Fraktal MIRA 
' MIRA.BAS
' Erstellt Maerz 2006
' Letzte Uberarbeitung 20.12.13
'=========================================================================
      
      
#include "Inc\TUI.bas"


Dim Shared As Single a, b, x0, y0, x, y, xmax
Dim Shared As Integer Farbe
Dim As Single x_alt
Dim As Integer n
Dim As String*1 jn


Sub Info
  Zentriert(1, "Programm MIRA")
  Print
  Print "vgl. H. Lauwerier: Fraktale, 1989, Kapitel 8"
  Print
  Print "Bildung der Punktreihe"
  Print "  x(n) = b * y(n-1) + F(x(n-1))"
  Print "  y(n) = -x(n-1) + F(x(n))"
  Print "mit"
  Print "  F(x) = a*x + (1-a)*(2*x^2/(1+x^2))"
  Print 
  Print "Parameterwahl: a = -1 bis +1, b = 1 oder etwas kleiner."
End Sub


Sub Dateneingabe
  
  Dim As String Maske(5), s(5)
    
  Maske(0) = "a ...................: ": s(0) = Str(a)
  Maske(1) = "b ...................: ": s(1) = Str(b)
  Maske(2) = "Startwert x0 ........: ": s(2) = Str(x0)
  Maske(3) = "Startwert y0 ........: ": s(3) = Str(y0)
  Maske(4) = "Fensterbreite      +/- ": s(4) = Str(xmax)
  Maske(5) = "Farbe (1 bis 15).....: ": s(5) = Str(Farbe)  
   
  Rahmen("Dateneingabe", "Beenden mit ESC", 13, 20, 22, 60)
  Locate 15, 22
  Eingabe(Maske(), s(), 15)
  Locate 25, 1
    
  a     = Val(s(0))
  b     = Val(s(1))
  x0    = Val(s(2))
  y0    = Val(s(3))
  xmax  = Val(s(4))
  Farbe = Val(s(5))
   
End Sub
  

Function F(x As Single) As Single
  F = a*x + (1-a)*(2*x^2/(1+x^2))
End Function 


'--------------------------- Hauptprogramm: -----------------------------------


'Vorbelegte Werte:
a = -0.15
b = 0.998
x0 = 3
y0 = 0
xmax = 16
Farbe = 9

Do
  
  Screen 0
  Color 7, 1
  Cls
  
  Info
  Dateneingabe
  
  Screenres 640, 480
  Windowtitle "Mira-Fraktal"
  Width 80, 30
  Window (-xmax, -0.7*xmax) - (xmax, 0.7*xmax)
  x = x0
  y = y0
  For n = 1 To 1E6
    x_alt = x
    x = b*y + F(x_alt)
    y = -x_alt + F(x)
    Pset (x, y), Farbe
  Next
  
  Locate 29, 30
  Input "Noch einmal j/n: ", jn
  
Loop Until Ucase(jn) = "N"

End


